#include<bits/stdc++.h>
typedef long long ll;
#define mp make_pair
using namespace std;
const int maxn=(int)2e5+10;
int n,m;
pair<int,int>a[maxn];
pair<pair<int,int>,int>st[8*maxn+10];
int lim=0;
int gl,gr,val;
void build(int node, int tl, int tr)
{
    lim=max(lim,node);
    if (tl==tr)
    {
        st[node]=mp(a[tl],1);
        return;
    }
    int mid=(tl+tr)/2;
    build(2*node,tl,mid);
    build(2*node+1,mid+1,tr);
    st[node]=mp(mp(max(st[2*node].first.first,st[2*node+1].first.first),min(st[2*node].first.second,st[2*node+1].first.second)),st[2*node].second+st[2*node+1].second);
    if (st[node].first.first>st[node].first.second)
        st[node].second=0;
}
int query(int node, int tl, int tr)
{
    if (node>lim)
        return 0;
    if (gl<=tl && tr<=gr)
        if (st[node].second!=0 && st[node].first.first<=val && val<=st[node].first.second)
            return st[node].second;
    int mid=(tl+tr)/2;
    int x=0;
    if (mid>=gl) x+=query(2*node,tl,mid);
    if (mid+1<=gr) x+=query(2*node+1,mid+1,tr);
    return x;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m;
    for (int i=1; i<=n; i++)
        cin >> a[i].first >> a[i].second;
    build(1,1,n);
    while (m--)
    {
        cin >> gl >> gr >> val;
        cout << query(1,1,n) << "\n";
    }
    return 0;
}